# $Id$
# $URL$

use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Util;

use Encode;
use Exporter 'import';

our @EXPORT_OK = qw(iso8601 iso8601_date iso8601_strict path_encode coalesce);
our %EXPORT_TAGS = (all => \@EXPORT_OK);  

sub iso8601 {
	my ($sec, $min, $hour, $mday, $mon, $year) = @_;
	return sprintf('%04d-%02d-%02d %02d:%02d:%02d',
		$year + 1900, $mon + 1, $mday, $hour, $min, $sec)
}

sub iso8601_date {
	my (undef, undef, undef, $mday, $mon, $year) = @_;
	return sprintf('%04d-%02d-%02d',
		$year + 1900, $mon + 1, $mday)
}

sub iso8601_strict {
	my ($sec, $min, $hour, $mday, $mon, $year) = @_;
	return sprintf('%04d-%02d-%02dT%02d:%02d:%02d',
		$year + 1900, $mon + 1, $mday, $hour, $min, $sec)
}

# dom/Tracky/Archive.pm:  $link->setAttribute('href', path_encode('//torrents.speedsubs.org', $filename));
# dom/Tracky/Files.pm:    $link->setAttribute('href', path_encode('/torrents', $file));
# dom/Tracky/Overview.pm: $link->setAttribute('href', path_encode('//torrents.speedsubs.org', $file));

sub path_encode {
	my $path = encode_utf8(join('/', @_));
	$path =~ s|[^A-Za-z0-9./_()-]|'%'.uc(unpack('H999',$&))|ge;
	return $path;
}

sub coalesce {
	while(@_ && !defined $_[0]) {
		shift @_
	}
	return $_[0]
}
